{-# INCLUDE <dlfcn.h> #-}
{-# LINE 1 "DLPrim.hsc" #-}
--  Haskell Binding for dl{open,sym,...}          -*-haskell-*-
{-# LINE 2 "DLPrim.hsc" #-}
--
--  Author : Volker Stolz <stolz@i2.informatik.rwth-aachen.de>
--
--  Created: 2001-11-22
--
--  Derived from GModule.chs by M.Weber & M.Chakravarty which is part of c2hs
--  I left the API more or less the same, mostly the flags are different.
--
--  License: BSD
--

module DLPrim
  {-# DEPRECATED "Use System.Posix.DynamicLinker.Prim instead" #-}
  (
  dlopen,
  dlsym,
  dlerror,
  dlclose,
  -- dlAddr, -- XXX NYI
  haveRtldNext,
  haveRtldLocal,
  packModuleFlags,
  ModuleFlags(..),
  Source(..)
 )

where

import Data.Bits	( (.|.) )
import Foreign.Ptr	( Ptr, FunPtr )
import Foreign.C.Types	( CInt )
import Foreign.C.String	( CString )
import System.Posix.DynamicLinker.Prim ( haveRtldNext, haveRtldLocal )


{-# LINE 37 "DLPrim.hsc" #-}

-- data type definition
-- --------------------

-- flags passed to `moduleOpen' (EXPORTED)
--
data ModuleFlags 
  = RTLD_LAZY
  | RTLD_NOW
  | RTLD_GLOBAL 
  | RTLD_LOCAL
    deriving (Show, Read)

foreign import ccall unsafe "dlopen" dlopen :: CString -> CInt -> IO (Ptr ())
foreign import ccall unsafe "dlsym"  dlsym  :: (Ptr ()) -> CString -> IO (FunPtr a)
foreign import ccall unsafe "dlerror" dlerror :: IO CString
foreign import ccall unsafe "dlclose" dlclose :: (Ptr ()) -> IO ()

packModuleFlags :: [ModuleFlags] -> CInt
packModuleFlags flags = foldl (\ s f -> (packOneModuleFlag f) .|. s) 0 flags

packOneModuleFlag :: ModuleFlags -> CInt
packOneModuleFlag RTLD_LAZY = 1
{-# LINE 60 "DLPrim.hsc" #-}


{-# LINE 62 "DLPrim.hsc" #-}
packOneModuleFlag RTLD_NOW = 2
{-# LINE 63 "DLPrim.hsc" #-}

{-# LINE 66 "DLPrim.hsc" #-}


{-# LINE 68 "DLPrim.hsc" #-}
packOneModuleFlag RTLD_GLOBAL = 256
{-# LINE 69 "DLPrim.hsc" #-}

{-# LINE 72 "DLPrim.hsc" #-}


{-# LINE 74 "DLPrim.hsc" #-}
packOneModuleFlag RTLD_LOCAL = 0
{-# LINE 75 "DLPrim.hsc" #-}

{-# LINE 78 "DLPrim.hsc" #-}

data Source = Null | Next | Default | Name CString
